From ab2da507db52e02805fb9bf8bcdef861f5b53b6f Mon Sep 17 00:00:00 2001
From: wagerlabs <joelr1@gmail.com>
Date: Wed, 29 Dec 2010 22:06:17 +0000
Subject: [PATCH] no errors

---
 swigp4.ml |   91 +++++++++++++++++++++++++++++++-----------------------------
 1 files changed, 47 insertions(+), 44 deletions(-)

diff --git a/swigp4.ml b/swigp4.ml
index ab29e6f..0c3e248 100644
--- a/swigp4.ml
+++ b/swigp4.ml
@@ -1,5 +1,8 @@
-open Pcaml ;;
+open Camlp4.PreCast
+open Camlp4.Sig
+open Syntax
 
+let _loc = Loc.ghost
 let lap x y = x :: y
 let c_ify e loc = 	  
   match e with
@@ -15,39 +18,39 @@ let mk_list args loc f =
     match args with
 	[] -> <:expr< [] >>
       | x :: xs ->
-	  (let loc = MLast.loc_of_expr x in
-	     <:expr< [ ($f x loc$) ] @ ($mk_list_inner xs loc f$) >>) in
+	  (let loc = Ast.loc_of_expr x in
+	     <:expr< [ ($f x _loc$) ] @ ($mk_list_inner xs loc f$) >>) in
     match args with
 	[] -> <:expr< (Obj.magic C_void) >>
-      | [ a ] -> <:expr< (Obj.magic $f a loc$) >>
+      | [ a ] -> <:expr< (Obj.magic $f a _loc$) >>
       | _ -> <:expr< (Obj.magic (C_list ($mk_list_inner args loc f$))) >>
 
-EXTEND
+EXTEND Gram
   expr:
   [ [ e1 = expr ; "'" ; "[" ; e2 = expr ; "]" ->
-	<:expr< (invoke $e1$) "[]" (C_list [ $c_ify e2 loc$ ]) >>
+	<:expr< (invoke $e1$) "[]" (C_list [ $c_ify e2 _loc$ ]) >>
     | e1 = expr ; "->" ; l = LIDENT ; "(" ; args = LIST0 (expr LEVEL "simple") SEP "," ; ")" ->
-	<:expr< (invoke $e1$) $str:l$ ($mk_list args loc c_ify$) >>
+	<:expr< (invoke $e1$) $str:l$ ($mk_list args _loc c_ify$) >>
     | e1 = expr ; "->" ; u = UIDENT ; "(" ; args = LIST0 (expr LEVEL "simple") SEP "," ; ")" ->
-	<:expr< (invoke $e1$) $str:u$ ($mk_list args loc c_ify$) >>
+	<:expr< (invoke $e1$) $str:u$ ($mk_list args _loc c_ify$) >>
     | e1 = expr ; "->" ; s = expr LEVEL "simple" ; "(" ; args = LIST0 (expr LEVEL "simple") SEP "," ; ")" ->
-	<:expr< (invoke $e1$) $s$ ($mk_list args loc c_ify$) >>
+	<:expr< (invoke $e1$) $s$ ($mk_list args _loc c_ify$) >>
     | e1 = expr ; "'" ; "." ; "(" ; args = LIST0 (expr LEVEL "simple") SEP "," ; ")" ->
-	<:expr< (invoke $e1$) "()" ($mk_list args loc c_ify$) >>
+	<:expr< (invoke $e1$) "()" ($mk_list args _loc c_ify$) >>
     | e1 = expr ; "'" ; "->" ; l = LIDENT ; "(" ; args = LIST0 (expr LEVEL "simple") SEP "," ; ")" ->
-	<:expr< (invoke ((invoke $e1$) "->" C_void)) $str:l$ ($mk_list args loc c_ify$) >>
+	<:expr< (invoke ((invoke $e1$) "->" C_void)) $str:l$ ($mk_list args _loc c_ify$) >>
     | e1 = expr ; "'" ; "->" ; u = UIDENT ; "(" ; args = LIST0 (expr LEVEL "simple") SEP "," ; ")" ->
-	<:expr< (invoke ((invoke $e1$) "->" C_void)) $str:u$ ($mk_list args loc c_ify$) >>
+	<:expr< (invoke ((invoke $e1$) "->" C_void)) $str:u$ ($mk_list args _loc c_ify$) >>
     | e1 = expr ; "'" ; "->" ; s = expr LEVEL "simple" ; "(" ; args = LIST0 (expr LEVEL "simple") SEP "," ; ")" ->
-	<:expr< (invoke ((invoke $e1$) "->" C_void)) $s$ ($mk_list args loc c_ify$) >>
+	<:expr< (invoke ((invoke $e1$) "->" C_void)) $s$ ($mk_list args _loc c_ify$) >>
     | e1 = expr ; "'" ; "++" ->
 	<:expr< (invoke $e1$) "++" C_void >>
     | e1 = expr ; "'" ; "--" ->
 	<:expr< (invoke $e1$) "--" C_void >>
     | e1 = expr ; "'" ; "-" ; e2 = expr ->
-	<:expr< (invoke $e1$) "-" (C_list [ $c_ify e2 loc$ ]) >>
-    | e1 = expr ; "'" ; "+" ; e2 = expr -> <:expr< (invoke $e1$) "+" (C_list [ $c_ify e2 loc$ ])  >> 
-    | e1 = expr ; "'" ; "*" ; e2 = expr -> <:expr< (invoke $e1$) "*" (C_list [ $c_ify e2 loc$ ])  >> 
+	<:expr< (invoke $e1$) "-" (C_list [ $c_ify e2 _loc$ ]) >>
+    | e1 = expr ; "'" ; "+" ; e2 = expr -> <:expr< (invoke $e1$) "+" (C_list [ $c_ify e2 _loc$ ])  >> 
+    | e1 = expr ; "'" ; "*" ; e2 = expr -> <:expr< (invoke $e1$) "*" (C_list [ $c_ify e2 _loc$ ])  >> 
     | "'" ; "&" ; e1 = expr -> 
 	<:expr< (invoke $e1$) "&" C_void >> 
     | "'" ; "!" ; e1 = expr ->
@@ -55,64 +58,64 @@ EXTEND
     | "'" ; "~" ; e1 = expr ->
 	<:expr< (invoke $e1$) "~" C_void >>
     | e1 = expr ; "'" ; "/" ; e2 = expr ->
-	<:expr< (invoke $e1$) "/" (C_list [ $c_ify e2 loc$ ]) >>
+	<:expr< (invoke $e1$) "/" (C_list [ $c_ify e2 _loc$ ]) >>
     | e1 = expr ; "'" ; "%" ; e2 = expr ->
-	<:expr< (invoke $e1$) "%" (C_list [ $c_ify e2 loc$ ]) >>
+	<:expr< (invoke $e1$) "%" (C_list [ $c_ify e2 _loc$ ]) >>
     | e1 = expr ; "'" ; "lsl" ; e2 = expr ->
-	<:expr< (invoke $e1$) ("<" ^ "<") (C_list [ $c_ify e2 loc$ ]) >>
+	<:expr< (invoke $e1$) ("<" ^ "<") (C_list [ $c_ify e2 _loc$ ]) >>
     | e1 = expr ; "'" ; "lsr" ; e2 = expr ->
-	<:expr< (invoke $e1$) (">" ^ ">") (C_list [ $c_ify e2 loc$ ]) >>
+	<:expr< (invoke $e1$) (">" ^ ">") (C_list [ $c_ify e2 _loc$ ]) >>
     | e1 = expr ; "'" ; "<" ; e2 = expr ->
-	<:expr< (invoke $e1$) "<" (C_list [ $c_ify e2 loc$ ]) >>
+	<:expr< (invoke $e1$) "<" (C_list [ $c_ify e2 _loc$ ]) >>
     | e1 = expr ; "'" ; "<=" ; e2 = expr ->
-	<:expr< (invoke $e1$) "<=" (C_list [ $c_ify e2 loc$ ]) >>
+	<:expr< (invoke $e1$) "<=" (C_list [ $c_ify e2 _loc$ ]) >>
     | e1 = expr ; "'" ; ">" ; e2 = expr ->
-	<:expr< (invoke $e1$) ">" (C_list [ $c_ify e2 loc$ ]) >>
+	<:expr< (invoke $e1$) ">" (C_list [ $c_ify e2 _loc$ ]) >>
     | e1 = expr ; "'" ; ">=" ; e2 = expr ->
-	<:expr< (invoke $e1$) ">=" (C_list [ $c_ify e2 loc$ ]) >>
+	<:expr< (invoke $e1$) ">=" (C_list [ $c_ify e2 _loc$ ]) >>
     | e1 = expr ; "'" ; "==" ; e2 = expr ->
-	<:expr< (invoke $e1$) "==" (C_list [ $c_ify e2 loc$ ]) >>
+	<:expr< (invoke $e1$) "==" (C_list [ $c_ify e2 _loc$ ]) >>
     | e1 = expr ; "'" ; "!=" ; e2 = expr ->
-	<:expr< (invoke $e1$) "!=" (C_list [ $c_ify e2 loc$ ]) >>
+	<:expr< (invoke $e1$) "!=" (C_list [ $c_ify e2 _loc$ ]) >>
     | e1 = expr ; "'" ; "&" ; e2 = expr ->
-	<:expr< (invoke $e1$) "&" (C_list [ $c_ify e2 loc$ ]) >>
+	<:expr< (invoke $e1$) "&" (C_list [ $c_ify e2 _loc$ ]) >>
     | e1 = expr ; "'" ; "^" ; e2 = expr ->
-	<:expr< (invoke $e1$) "^" (C_list [ $c_ify e2 loc$ ]) >>
+	<:expr< (invoke $e1$) "^" (C_list [ $c_ify e2 _loc$ ]) >>
     | e1 = expr ; "'" ; "|" ; e2 = expr ->
-	<:expr< (invoke $e1$) "|" (C_list [ $c_ify e2 loc$ ]) >>
+	<:expr< (invoke $e1$) "|" (C_list [ $c_ify e2 _loc$ ]) >>
     | e1 = expr ; "'" ; "&&" ; e2 = expr ->
-	<:expr< (invoke $e1$) "&&" (C_list [ $c_ify e2 loc$ ]) >>
+	<:expr< (invoke $e1$) "&&" (C_list [ $c_ify e2 _loc$ ]) >>
     | e1 = expr ; "'" ; "||" ; e2 = expr ->
-	<:expr< (invoke $e1$) "||" (C_list [ $c_ify e2 loc$ ]) >>
+	<:expr< (invoke $e1$) "||" (C_list [ $c_ify e2 _loc$ ]) >>
     | e1 = expr ; "'" ; "=" ; e2 = expr ->
-	<:expr< (invoke $e1$) "=" (C_list [ $c_ify e2 loc$ ]) >>
+	<:expr< (invoke $e1$) "=" (C_list [ $c_ify e2 _loc$ ]) >>
     | e1 = expr ; "'" ; "+=" ; e2 = expr ->
-	<:expr< (invoke $e1$) "+=" (C_list [ $c_ify e2 loc$ ]) >>
+	<:expr< (invoke $e1$) "+=" (C_list [ $c_ify e2 _loc$ ]) >>
     | e1 = expr ; "'" ; "-=" ; e2 = expr ->
-	<:expr< (invoke $e1$) "-=" (C_list [ $c_ify e2 loc$ ]) >>
+	<:expr< (invoke $e1$) "-=" (C_list [ $c_ify e2 _loc$ ]) >>
     | e1 = expr ; "'" ; "*=" ; e2 = expr ->
-	<:expr< (invoke $e1$) "*=" (C_list [ $c_ify e2 loc$ ]) >>
+	<:expr< (invoke $e1$) "*=" (C_list [ $c_ify e2 _loc$ ]) >>
     | e1 = expr ; "'" ; "/=" ; e2 = expr ->
-	<:expr< (invoke $e1$) "/=" (C_list [ $c_ify e2 loc$ ]) >>
+	<:expr< (invoke $e1$) "/=" (C_list [ $c_ify e2 _loc$ ]) >>
     | e1 = expr ; "'" ; "%=" ; e2 = expr ->
-	<:expr< (invoke $e1$) "%=" (C_list [ $c_ify e2 loc$ ]) >>
+	<:expr< (invoke $e1$) "%=" (C_list [ $c_ify e2 _loc$ ]) >>
     | e1 = expr ; "'" ; "lsl" ; "=" ; e2 = expr ->
-	<:expr< (invoke $e1$) ("<" ^ "<=") (C_list [ $c_ify e2 loc$ ]) >>
+	<:expr< (invoke $e1$) ("<" ^ "<=") (C_list [ $c_ify e2 _loc$ ]) >>
     | e1 = expr ; "'" ; "lsr" ; "=" ; e2 = expr ->
-	<:expr< (invoke $e1$) (">" ^ ">=") (C_list [ $c_ify e2 loc$ ]) >>
+	<:expr< (invoke $e1$) (">" ^ ">=") (C_list [ $c_ify e2 _loc$ ]) >>
     | e1 = expr ; "'" ; "&=" ; e2 = expr ->
-	<:expr< (invoke $e1$) "&=" (C_list [ $c_ify e2 loc$ ]) >>
+	<:expr< (invoke $e1$) "&=" (C_list [ $c_ify e2 _loc$ ]) >>
     | e1 = expr ; "'" ; "^=" ; e2 = expr ->
-	<:expr< (invoke $e1$) "^=" (C_list [ $c_ify e2 loc$ ]) >> 
+	<:expr< (invoke $e1$) "^=" (C_list [ $c_ify e2 _loc$ ]) >> 
     | e1 = expr ; "'" ; "|=" ; e2 = expr ->
-	<:expr< (invoke $e1$) "|=" (C_list [ $c_ify e2 loc$ ]) >>
-    | "'" ; e = expr -> c_ify e loc
+	<:expr< (invoke $e1$) "|=" (C_list [ $c_ify e2 _loc$ ]) >>
+    | "'" ; e = expr -> c_ify e _loc
     | c = expr ; "as" ; id = LIDENT -> <:expr< $lid:"get_" ^ id$ $c$ >>
     | c = expr ; "to" ; id = LIDENT -> <:expr< $uid:"C_" ^ id$ $c$ >>
     | "`" ; "`" ; l = LIDENT -> <:expr< C_enum `$lid:l$ >>
     | "`" ; "`" ; u = UIDENT -> <:expr< C_enum `$uid:u$ >>
     | f = expr ; "'" ; "(" ; args = LIST0 (expr LEVEL "simple") SEP "," ; ")" -> 
-	<:expr< $f$ ($mk_list args loc c_ify$) >>
+	<:expr< $f$ ($mk_list args _loc c_ify$) >>
     ] ] ;
 END ;;
       
-- 
1.7.3.1

